<?php
namespace cloud\apps\sac\iwan;


function select($data)
{
	global $user;

	$optional = array();
	$result = array(
		'rows'		=> array(),
		'total'		=> 0,
	);

	$now = strtotime("now");
	$result['now'] = $now;

	// set custom options
	format_and_push($data, 'idx', $optional, '', 'int', false);
	format_and_push($data, 'keyword', $optional, '', 'string', true);

	// 设置用户组
	if(format_and_push($data, 'grpid', $optional, '', 'int', false) == false)
		$optional['grpid'] = -1;
	
	
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(4, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if(!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] == -1)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
		}
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " iwanpool list idx={$optional['idx']}";
	$cmd.= " grpid={$optional['grpid']} name={$optional['keyword']}";

	$page_arg = get_query_page($data);
	$cmd.= " page={$page_arg['page']} limit={$page_arg['limit']}";
	$cmd.= " sort={$page_arg['sort']} sortdesc={$page_arg['sortdesc']}";

	exec($cmd, $out, $ret);

	return implode('', $out);
//	$result['rows'] = implode('', $out);

//	return $result;
}


function select_ap_config($data)
{
	global $user;

	$optional = array();
	$result = array(
		'rows'		=> array(),
		'total'		=> 0,
	);

	$now = strtotime("now");
	$result['now'] = $now;

	// set custom options
	format_and_push($data, 'apids', $optional, '', 'string', true);
	
	// 设置用户组
	if(format_and_push($data, 'grpid', $optional, '', 'int', false) == false)
		$optional['grpid'] = -1;

	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(4, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if(!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] == -1)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
		}
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " sac list retfmt=4";
	$cmd.= " apids={$optional['apids']} grpid={$optional['grpid']}";
	$cmd.= " name={$optional['keyword']}";

	$page_arg = get_query_page($data);
	$cmd.= " page={$page_arg['page']} limit={$page_arg['limit']}";
	$cmd.= " sort={$page_arg['sort']} sortdesc={$page_arg['sortdesc']}";

	exec($cmd, $out, $ret);

	return implode('', $out);
//	$result['rows'] = implode('', $out);

//	return $result;
}

function ap_enable($data)
{
	global $user;
	
	$optional = array();

	// set custom options
	if(!isset($data['apid']) || ($optional['apid'] = intval($data['apid'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的iWAN无效！');
		return false;
	}
	if(format_and_push($data, 'enable', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " sac set apid={$optional['apid']}";
	$cmd.= " iwan_task_enable={$optional['enable']}";

	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");

	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function add($data)
{
	global $user;
	
	$optional = array(
		'svrip' => '',
		'svrdomain' => '',
	);

	// set custom options
	if(format_and_push($data, 'user', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}
	if(format_and_push($data, 'svrhost', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '服务主机不能为空！');
		return false;
	}
	if(is_ipaddr($optional['svrhost']))
		$optional['svrip'] = $optional['svrhost'];
	else
		$optional['svrdomain'] = $optional['svrhost'];

	if(format_and_push($data, 'svrport', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}
	if($optional['svrport'] < 0 || $optional['svrport'] > 65535) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}
	if(format_and_push($data, 'ssid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, 'iWAN-SSID不能为空！');
		return false;
	}
	if(format_and_push($data, 'ridx', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请选择一个要生效的2G/5G射频！');
		return false;
	}

	format_and_push($data, 'encrypt', $optional, '', 'int', false);
	format_and_push($data, 'pass', $optional, '', 'string', true);

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " iwanpool add";
	$cmd.= " user={$optional['user']} pass={$optional['pass']} encrypt={$optional['encrypt']}";
	$cmd.= " svrip={$optional['svrip']} svrdomain={$optional['svrdomain']} svrport={$optional['svrport']}";
	$cmd.= " ssid={$optional['ssid']} ridx={$optional['ridx']}";

	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");

	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function save($data)
{
	global $user;
	
	$optional = array(
		'svrip' => '',
		'svrdomain' => '',
	);

	// set custom options
	if(!isset($data['id']) || ($optional['id'] = intval($data['id'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的iWAN无效！');
		return false;
	}
	
	if(format_and_push($data, 'user', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}
	if(format_and_push($data, 'svrhost', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '服务主机不能为空！');
		return false;
	}
	if(is_ipaddr($optional['svrhost']))
		$optional['svrip'] = $optional['svrhost'];
	else
		$optional['svrdomain'] = $optional['svrhost'];

	if(format_and_push($data, 'svrport', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}
	if($optional['svrport'] < 0 || $optional['svrport'] > 65535) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}
	if(format_and_push($data, 'ssid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, 'iWAN-SSID不能为空！');
		return false;
	}
	if(format_and_push($data, 'ridx', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请选择一个要生效的2G/5G射频！');
		return false;
	}

	format_and_push($data, 'encrypt', $optional, '', 'int', false);
	format_and_push($data, 'pass', $optional, '', 'string', true);

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " iwanpool set idx={$optional['id']}";
	$cmd.= " user={$optional['user']} pass={$optional['pass']} encrypt={$optional['encrypt']}";
	$cmd.= " svrip={$optional['svrip']} svrdomain={$optional['svrdomain']} svrport={$optional['svrport']}";
	$cmd.= " ssid={$optional['ssid']} ridx={$optional['ridx']}";

	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");

	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function remove($data)
{
	global $user;
	
	$optional = array();
	$result = array();

	// set custom options
	if(!isset($data['id']) || ($optional['id'] = intval($data['id'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的iWAN无效！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}
	
	$cmd = SACEYE . " iwanpool remove idx={$optional['id']}";
	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");
	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}
